//---------------------------------------------------------------------------

#ifndef mainH
#define mainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Grids.hpp>
#include <Menus.hpp>

#include "role.h"
//---------------------------------------------------------------------------
enum TEditKind{ekTerrs, ekItems, ekRole}; // TؽsҦ: a, ~ΥD

class TMainForm : public TForm
{
__published:	// IDE-managed Components
        TPanel *pnlView;
        TPaintBox *pbxView;
        TDrawGrid *grdPreview;
        TGroupBox *GroupBox1;
        TLabel *lblTileNo;
        TNotebook *nbkTileAttr;
        TCheckBox *cbxCanPass;
        TCheckBox *cbxTarget;
        TCheckBox *cbxSource;
        TCheckBox *cbxCanMove;
        TStatusBar *stbMain;
        TMainMenu *mnuMain;
        TMenuItem *F1;
        TMenuItem *mnuChooseLevel;
        TMenuItem *mnuSave;
        TMenuItem *N1;
        TMenuItem *mnuRestoreLevel;
        TMenuItem *N3;
        TMenuItem *mnuExit;
        TMenuItem *E1;
        TMenuItem *mnuEditTerrs;
        TMenuItem *mnuEditItems;
        TMenuItem *mnuEditRole;
        TMenuItem *N2;
        TMenuItem *mnuRemoveItem;
        TMenuItem *N4;
        TMenuItem *mnuResetTerrs;
        TMenuItem *mnuRemoveItems;
        TMenuItem *V1;
        TMenuItem *mnuShowGrid;
        TMenuItem *mnuShowSpeicalItems;
        TMenuItem *mnuShowSpeicalArea;
        TMenuItem *H1;
        TMenuItem *mnuAbout;
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall pbxViewPaint(TObject *Sender);
        void __fastcall mnuExitClick(TObject *Sender);
        void __fastcall mnuChooseLevelClick(TObject *Sender);
        void __fastcall mnuSaveClick(TObject *Sender);
        void __fastcall mnuRestoreLevelClick(TObject *Sender);
        void __fastcall mnuEditKindClick(TObject *Sender);
        void __fastcall mnuRemoveItemClick(TObject *Sender);
        void __fastcall mnuResetTerrsClick(TObject *Sender);
        void __fastcall mnuShowSomethingClick(TObject *Sender);
        void __fastcall mnuAboutClick(TObject *Sender);
        void __fastcall pbxViewMouseMove(TObject *Sender,
          TShiftState Shift, int X, int Y);
        void __fastcall grdPreviewDrawCell(TObject *Sender, int ACol,
          int ARow, TRect &Rect, TGridDrawState State);
        void __fastcall grdPreviewClick(TObject *Sender);
        void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
        void __fastcall pbxViewMouseUp(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall pbxViewMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
private:	// User declarations
    TEditKind FEditKind; // ثesҦ
    int FLevelNo; // ثes誺d
    bool FModified; // JdO_ʹL

    TRole FRole; // ⪫
    Graphics::TBitmap* FBackBitmap; // double-buffering ΪI bitmap

    int FCursorX, FCursorY; // ƹЦm
    TMouseButton FButtonPressed; // ƹ䪬A

    void __fastcall DrawBackBitmap(); // øsI bitmap
    void __fastcall UpdateView(); // sse
    void __fastcall UpdateControlStatus();

    void __fastcall SetLevelNo(int Value);

    void __fastcall MySaveMap(); // xsaɮ
    bool __fastcall AskSaveMap(); // T{O_xsa
    bool __fastcall ValidateMap(); // ˬdaϬO_Xk

    __property int LevelNo = {read = FLevelNo, write = SetLevelNo};
public:		// User declarations
        __fastcall TMainForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif
