//---------------------------------------------------------------------------

#ifndef mainH
#define mainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Dialogs.hpp>
#include <ExtCtrls.hpp>
#include <ExtDlgs.hpp>
#include <Grids.hpp>
#include <Menus.hpp>

#include <typeinfo>

#include "tileunit.h"
//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:	// IDE-managed Components
        TLabel *Label1;
        TLabel *Label2;
        TLabel *Label3;
        TLabel *Label4;
        TLabel *lblTileKind;
        TLabel *lblTileNum;
        TDrawGrid *grdPreview;
        TGroupBox *GroupBox1;
        TLabel *lblTileNo;
        TNotebook *nbkTileAttr;
        TCheckBox *cbxCanPass;
        TCheckBox *cbxTarget;
        TCheckBox *cbxSource;
        TCheckBox *cbxCanMove;
        TMainMenu *mnuMain;
        TMenuItem *F1;
        TMenuItem *mnuNew;
        TMenuItem *mnuOpen;
        TMenuItem *N3;
        TMenuItem *mnuSave;
        TMenuItem *mnuSaveAs;
        TMenuItem *N1;
        TMenuItem *mnuImport;
        TMenuItem *N2;
        TMenuItem *mnuExit;
        TMenuItem *H1;
        TMenuItem *mnuAbout;
        TOpenDialog *dlgOpen;
        TSaveDialog *dlgSave;
        TOpenPictureDialog *dlgOpenPicture;
        void __fastcall mnuExitClick(TObject *Sender);
        void __fastcall mnuAboutClick(TObject *Sender);
        void __fastcall mnuNewClick(TObject *Sender);
        void __fastcall mnuOpenClick(TObject *Sender);
        void __fastcall mnuSaveClick(TObject *Sender);
        void __fastcall mnuImportClick(TObject *Sender);
        void __fastcall grdPreviewDrawCell(TObject *Sender, int ACol,
          int ARow, TRect &Rect, TGridDrawState State);
        void __fastcall grdPreviewSelectCell(TObject *Sender, int ACol,
          int ARow, bool &CanSelect);
        void __fastcall FormCreate(TObject *Sender);
private:	// User declarations
    TTiles* FTiles;
    AnsiString FFileName;
    int FOldSelection;

    void __fastcall UpdateControlStatus();
    void __fastcall CreateTiles(const std::type_info&);
public:		// User declarations
        __fastcall TMainForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif
