//---------------------------------------------------------------------------

#ifndef mainH
#define mainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>

#include "role.h"
//---------------------------------------------------------------------------
// |تA, Title e, C, YdιL^U
enum TGameStatus {gsTitle, gsPlaying, gsSuccess, gsPlayBack};

class TMainForm : public TForm
{
__published:	// IDE-managed Components
        TPanel *pnlView;
        TPaintBox *pbxView;
        TMainMenu *mnuMain;
        TMenuItem *mnuGame;
        TMenuItem *mnuStartGame;
        TMenuItem *mnuRestart;
        TMenuItem *N2;
        TMenuItem *mnuChooseLevel;
        TMenuItem *N3;
        TMenuItem *mnuPrevLevel;
        TMenuItem *mnuNextLevel;
        TMenuItem *N1;
        TMenuItem *mnuExit;
        TMenuItem *P1;
        TMenuItem *mnuPlayBack;
        TMenuItem *mnuHelp;
        TMenuItem *mnuAbout;
        TTimer *tmrTimer;
        TTimer *tmrPlayBack;
        TTimer *tmrTitle;
        void __fastcall pbxViewPaint(TObject *Sender);
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall mnuStartGameClick(TObject *Sender);
        void __fastcall mnuChooseLevelClick(TObject *Sender);
        void __fastcall mnuRestartClick(TObject *Sender);
        void __fastcall mnuPrevLevelClick(TObject *Sender);
        void __fastcall mnuExitClick(TObject *Sender);
        void __fastcall mnuPlayBackClick(TObject *Sender);
        void __fastcall mnuAboutClick(TObject *Sender);
        void __fastcall tmrTimerTimer(TObject *Sender);
        void __fastcall tmrPlayBackTimer(TObject *Sender);
        void __fastcall tmrTitleTimer(TObject *Sender);
        void __fastcall FormKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
private:	// User declarations
    TGameStatus FGameStatus; // CA
    int FLevelNo, FPlayingTime; // ثedιCiɶ
    TRole FRole; // ⪫

    Graphics::TBitmap* FBackBitmap; // double-buffering ΪI bitmap
    int FPlayBackLevelNo; // iH playback  LevelNo

    void __fastcall DrawBackBitmap(); // øsI bitmap
    void __fastcall UpdateView(); // sse
    void __fastcall UpdateControlStatus();

    // bCeΥWøXrΥ~
    void __fastcall DrawStatusBox(AnsiString S, bool TopOrCenter);
    bool __fastcall CheckFinished(); // ˬdO_w

    void __fastcall SetGameStatus(TGameStatus Value);
    void __fastcall SetLevelNo(int Value);

    __property int LevelNo = {read = FLevelNo, write = SetLevelNo};
    __property TGameStatus GameStatus = {read = FGameStatus, write = SetGameStatus};
public:		// User declarations
        __fastcall TMainForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif
