//---------------------------------------------------------------------------

#ifndef roleH
#define roleH
//---------------------------------------------------------------------------

#include <Windows.hpp>
#include <Graphics.hpp>
#include <SysUtils.hpp>
#include <Classes.hpp>

#include <vector>

enum TDirection {drUp, drDown, drLeft, drRight};
typedef std::vector<TDirection> TDirectionArray;

class TRole {
private:
  int FX, FY; // y
  TDirection FDirection; // iV
  Graphics::TBitmap *FBits, *FInvBitmap; // ϤγzKϥιϤ

  TDirectionArray FPlayBackList, FMoveList; // \Ϊʧ@O

  TDirectionArray& GetPlayBackList() {return FPlayBackList;}
public:
  TRole();
  ~TRole();

  void LoadBits(); // J⪺ bitmap
  void Draw(TCanvas* Canvas); // øs
  void Move(TDirection Dir); // ʨ (IBz, ʪ~)

  void SavePlayBack(); // Nʧ@Oܭ
  void CleanMoveList(); // Mʧ@O

  // mΤV
  __property int X = {read = FX, write = FX};
  __property int Y = {read = FY, write = FY};
  __property TDirection Direction = {read = FDirection, write = FDirection};

  __property TDirectionArray& PlayBackList = {read = GetPlayBackList};
};


#endif
