//---------------------------------------------------------------------------

#ifndef utilH
#define utilH
//---------------------------------------------------------------------------

#undef VAR
#undef INI

#ifdef utilCPP
#define VAR
#define INI(x) = (x)
#else
#define VAR extern
#define INI(x)
#endif

#define TILE_WIDTH 32                   // ϤeI
#define TILE_HEIGHT 32                  // ϤI

#define TILE_NUM_X 10                   // eb
#define TILE_NUM_Y 10                   // eab

VAR const char* FN_TERR_ARCHIVE INI("TERR.TIA"); // aιϮw
VAR const char* FN_ITEM_ARCHIVE INI("ITEM.TIA"); // ~Ϯw
VAR const char* FN_ROLEBITS     INI("ROLEBITS.BMP"); // 

VAR const char* FN_MAP_PREFIX   INI("MAP"); // dɦW (MAP??.DAT)
VAR const char* FN_MAP_EXT      INI(".DAT"); // dɰɦW

VAR const char* SIG_MYFILE      INI("Xshadow_Stock"); // ϮwΦaɮתY

VAR void CheckSignature(TReader* reader, const AnsiString Sig);

VAR bool IsWindows98();

VAR void DrawTransparentBitmap(HDC hdc, HBITMAP hBitmap, short xStart,
                       short yStart, COLORREF cTransparentColor);

#endif
